; Parker Brothers prototype cartridge
; "C64 Download from IBM"
; 2/7/84

$8000: a2 00           LDX  #$00	; string table offset
$8002: 20 e5 80        JSR  $80e5	; print string: 0d,"RETURN TO DLOAD"
$8005: a9 00           LDA  #$00	;
$8007: 8d 03 dd        STA  $dd03	; CIA: Data Direction Register Port B (input)
$800a: ad 02 dd        LDA  $dd02	; CIA: Data Direction Register Port A (input)
$800d: 09 04           ORA  #$04	; User Port / RS-232 Data: set directioin to Output
$800f: 8d 02 dd        STA  $dd02	;
$8012: ad 00 dd        LDA  $dd00       ; CIA2: Data Port A
$8015: 29 fb           AND  #$fb	; clear flag: filter User Port / RS-232 Data Output
$8017: 8d 00 dd        STA  $dd00       ; CIA2
$801a: ad 0d dd        LDA  $dd0d	; CIA Interrupt Control Register

$801d: 20 cf ff        JSR  $ffcf       ; CHRIN (read from keyboard)
$8020: c9 0d           CMP  #$0d	; wait for "RETURN"
$8022: d0 f9           BNE  $801d	;

$8024: 20 c1 80        JSR  $80c1	; read a byte from the user port
$8027: 85 fd           STA  $fd		; => start address low byte
$8029: 20 c1 80        JSR  $80c1	; read a byte from the user port
$802c: 85 fe           STA  $fe		; => start address high byte
$802e: 20 c1 80        JSR  $80c1	; read a byte from the user port
$8031: 85 fb           STA  $fb		; => length low byte
$8033: 20 c1 80        JSR  $80c1	; read a byte from the user port
$8036: 85 fc           STA  $fc		; => length high byte
$8038: a2 11           LDX  #$11	; string table offset
$803a: 20 e5 80        JSR  $80e5	; print string: 0d,"START=$"
$803d: a5 fe           LDA  $fe		; (print start address)
$803f: a6 fd           LDX  $fd		;
$8041: 20 f1 80        JSR  $80f1	; print 16 bit hex number: A,X
$8044: a2 1a           LDX  #$1a	; string table offset
$8046: 20 e5 80        JSR  $80e5	; print string: 0d,"LENGTH=$"
$8049: a5 fc           LDA  $fc		; (print length)
$804b: a6 fb           LDX  $fb		;
$804d: 20 f1 80        JSR  $80f1	; print 16 bit hex number: A,X
$8050: a2 24           LDX  #$24	; string table offset
$8052: 20 e5 80        JSR  $80e5	; print string: 0d,"OFFSET=$",0d
$8055: 20 0e 81        JSR  $810e	; read 16 bit hex address from keyboard into $c3/$c4
$8058: ad 00 02        LDA  $0200	; first byte of input buffer
$805b: c9 0d           CMP  #$0d	; "RETURN"?
$805d: d0 03           BNE  $8062	; if no offset specified, start at $8000
$805f: 4c 00 80        JMP  $8000	; => restart download cartridge (?)
----------------------------------------
$8062: a5 c3           LDA  $c3		; offset low byte (from keyboard input)
$8064: 18              CLC  		;
$8065: 65 fd           ADC  $fd		; add to start address
$8067: 85 fd           STA  $fd		;
$8069: a5 c4           LDA  $c4		; offset high byte (from keyboard input)
$806b: 65 fe           ADC  $fe		; add to start address
$806d: 85 fe           STA  $fe		;
$806f: a5 fe           LDA  $fe		;
$8071: 85 fa           STA  $fa		; (start address, high byte)
$8073: a6 fd           LDX  $fd		;
$8075: 86 f9           STX  $f9		; (start address, low byte)
$8077: a2 6d           LDX  #$6d	; string table offset
$8079: 20 e5 80        JSR  $80e5	; print string: 0d,"START@$"
$807c: a5 fe           LDA  $fe		; (start address including offset)
$807e: a6 fd           LDX  $fd		;
$8080: 20 f1 80        JSR  $80f1	; print 16 bit hex number: A,X

$8083: 20 c1 80        JSR  $80c1	; read a byte from the user port
$8086: a0 00           LDY  #$00	; offset = 0
$8088: 91 fd           STA  ($fd),Y	; store in destination $fd/$fe
$808a: e6 fd           INC  $fd		; inc destination address
$808c: d0 02           BNE  $8090	;
$808e: e6 fe           INC  $fe		;

$8090: a5 fb           LDA  $fb		; decrement length $fb/$fc
$8092: d0 02           BNE  $8096	;
$8094: c6 fc           DEC  $fc		;
$8096: c6 fb           DEC  $fb		;
$8098: d0 e9           BNE  $8083	; continue copying
$809a: a5 fc           LDA  $fc		;
$809c: d0 e5           BNE  $8083	; continue copying

$809e: a2 2f           LDX  #$2f	; string table offset
$80a0: 20 e5 80        JSR  $80e5	; print string: 0d,"ENTER "R <<RETURN>>" TO RUN"
					; 0d,"OR RETURN ONLY TO EXIT TO BASIC",0d,00

$80a3: a0 00           LDY  #$00	; reset input buffer offset
$80a5: 20 cf ff        JSR  $ffcf       ; CHRIN (read from keyboard)
$80a8: c9 20           CMP  #$20	; " "
$80aa: f0 f9           BEQ  $80a5	; read over blanks
$80ac: 99 00 02        STA  $0200,Y	; store input at $0200
$80af: c8              INY  		;
$80b0: c9 0d           CMP  #$0d	; "ENTER"?
$80b2: d0 f1           BNE  $80a5	; read next character from keyboard

$80b4: ad 00 02        LDA  $0200	; first character of keyboard input
$80b7: 29 df           AND  #$df	;
$80b9: c9 52           CMP  #$52	; 'R'
$80bb: f0 01           BEQ  $80be	; => Run
$80bd: 60              RTS  		; (return to basic)
----------------------------------------
$80be: 6c f9 00        JMP  ($00f9)	; jump into start address $f9/fa
----------------------------------------
					; read a byte from the user port
$80c1: ad 0d dd        LDA  $dd0d	; CIA Interrupt Control Register
$80c4: 29 10           AND  #$10	; FLAG 1 NMI (User/RS-232 Received Data Input)
$80c6: f0 f9           BEQ  $80c1	; no interrupt =>
$80c8: ad 01 dd        LDA  $dd01	; CIA Data port B (User Port, RS-232)
$80cb: 48              PHA  		;
$80cc: ad 00 dd        LDA  $dd00       ; CIA2
$80cf: 09 04           ORA  #$04	; User Port, RS-232 Data Output (send handshake)
$80d1: 8d 00 dd        STA  $dd00       ; CIA2
$80d4: ad 0d dd        LDA  $dd0d	; CIA Interrupt Control Register
$80d7: 29 10           AND  #$10	; FLAG 1 NMI (User/RS-232 Received Data Input)
$80d9: f0 f9           BEQ  $80d4	; no interrupt =>
$80db: ad 00 dd        LDA  $dd00       ; CIA2
$80de: 29 fb           AND  #$fb	; User Port, RS-232 Data Output (release handshake)
$80e0: 8d 00 dd        STA  $dd00       ; CIA2
$80e3: 68              PLA  		; byte read from user port
$80e4: 60              RTS  		;
----------------------------------------
$80e5: bd 71 81        LDA  $8171,X	; print string "X"
$80e8: f0 06           BEQ  $80f0	; (end of string -> return)
$80ea: 20 d2 ff        JSR  $ffd2       ; CHROUT
$80ed: e8              INX  		;
$80ee: d0 f5           BNE  $80e5	; print next char
$80f0: 60              RTS  		;
----------------------------------------
					; print 16 bit hex number: A,X
$80f1: 86 f8           STX  $f8		; store X register in $f8
$80f3: 20 f8 80        JSR  $80f8	; print "A" as Hex number
$80f6: a5 f8           LDA  $f8		; restore and print "X" as Hex number

$80f8: 48              PHA  
$80f9: 4a              LSR  		; get high nibble
$80fa: 4a              LSR  		;
$80fb: 4a              LSR  		;
$80fc: 4a              LSR  		;
$80fd: 20 03 81        JSR  $8103	; print hex digit (high nibble)
$8100: 68              PLA  		;
$8101: 29 0f           AND  #$0f	; print hex digit (low nibble)

$8103: 09 30           ORA  #$30	; add character "0"
$8105: c9 3a           CMP  #$3a	; number larger than "9"?
$8107: 90 02           BCC  $810b	; no -> "0" ... "9"
$8109: 69 06           ADC  #$06	; add 7 (6 plus carry) => "A" ... "F"
$810b: 4c d2 ff        JMP  $ffd2       ; CHROUT
----------------------------------------
$810e: a0 00           LDY  #$00	; read 16 bit hex address from keyboard into $c3/$c4
$8110: 84 c3           STY  $c3		; clear 16 bit input field $c3/$c4
$8112: 84 c4           STY  $c4		;
$8114: 20 cf ff        JSR  $ffcf       ; CHRIN (read from keyboard)
$8117: c9 20           CMP  #$20	; ' '
$8119: f0 f9           BEQ  $8114	; read over blank(s)
$811b: 99 00 02        STA  $0200,Y	; store input at $0200
$811e: c8              INY  		;
$811f: c0 14           CPY  #$14	; 20 characters read?
$8121: f0 31           BEQ  $8154	; yes => too much input
$8123: c9 0d           CMP  #$0d	; "ENTER"?
$8125: d0 ed           BNE  $8114	; read next character from keyboard

$8127: a0 ff           LDY  #$ff	; start at offset 0
$8129: c8              INY  		;
$812a: b9 00 02        LDA  $0200,Y	;
$812d: c9 0d           CMP  #$0d	; end of input reached?
$812f: d0 01           BNE  $8132	; no -> check for input hex digit and rotate into $c3/$c4
$8131: 60              RTS  		; return with input hex address in $c3/$c4
----------------------------------------
$8132: e9 30           SBC  #$30	; '0'
$8134: 90 1e           BCC  $8154	; input character < '0'? => error
$8136: c9 0a           CMP  #$0a	;
$8138: 90 02           BCC  $813c	; input digit '0'...'9'? =>
$813a: e9 07           SBC  #$07	; otherwise 'A'...'F', subtract 7
$813c: c9 10           CMP  #$10	; > 0x0f?
$813e: b0 14           BCS  $8154	; if no hex digit given as input => error

$8140: 85 f8           STA  $f8		; store hex digit in $f8
$8142: a2 03           LDX  #$03	;
$8144: 06 c3           ASL  $c3		; shift 16 bit hex value $c3/$c4 4 bit to the left
$8146: 26 c4           ROL  $c4		;
$8148: ca              DEX  		;
$8149: 10 f9           BPL  $8144	;

$814b: a5 c3           LDA  $c3		; add the newly converted hex digit to $c3/$c4
$814d: 05 f8           ORA  $f8		;
$814f: 85 c3           STA  $c3		;
$8151: 4c 29 81        JMP  $8129	; read next hex digit
----------------------------------------
$8154: 20 e5 80        JSR  $80e5	; print string "X" (if X is not set to anything new, print old string again)

$8157:                      0d		; 0d,"ERROR: RE-ENTER DATA",0d,00
$8158: 45 52 52 4f 52 3a 20 52
$8160: 45 2d 45 4e 54 45 52 20
$8168: 44 41 54 41 0d 00

$816e: 4c 0e 81        JMP  $810e	; read 16 bit hex address from keyboard into $c3/$c4 (try again)

$8171:    0d 52 45 54 55 52 4e		; 0d,"RETURN TO DLOAD",00
$8178: 20 54 4f 20 44 4c 4f 41
$8180: 44 00

$8182:       0d 53 54 41 52 54		; 0d,"START=$",00
$8188: 3d 24 00

$818b:          0d 4c 45 4e 47		; 0d,"LENGTH=$",00
$8190: 54 48 3d 24 00

$8195:                0d 4f 46		; 0d,"OFFSET=$",0d,00
$8198: 46 53 45 54 3d 24 0d 00

$81a0: 0d 45 4e 54 45 52 20 22		; 0d,"ENTER "R <<RETURN>>" TO RUN
$81a8: 52 20 3c 3c 52 45 54 55		; 0d,"OR RETURN ONLY TO EXIT TO BASIC",0d,00
$81b0: 52 4e 3e 3e 22 20 54 4f
$81b8: 20 52 55 4e 0d 4f 52 20
$81c0: 52 45 54 55 52 4e 20 4f
$81c8: 4e 4c 59 20 54 4f 20 45
$81d0: 58 49 54 20 54 4f 20 42
$81d8: 41 53 49 43 0d 00

$81de:                   0d 53		; 0d,"START@$",00
$81e0: 54 41 52 54 40 24 00

$81e7: 00 

$81e8-8fff: ff
